package com.qihoo360.mobilesafe

import android.content.Context
import android.util.Base64
import com.qihoo.sdk.device.DeviceApi
import com.qihoo360.apullsdk.utils.AppVersionUtils
import com.qihoo360.apullsdk.utils.JsonHelper
import com.qihoo360.apullsdk.utils.SystemUtil
import com.qihoo360.i.Factory
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.newssdk.NewsSDK
import org.json.JSONArray
import org.json.JSONObject

class RewardSDK {

    companion object {
        var mContext: Context? = null
        var mIsSingleApk = false
        var mPhoneInfo = ""
        var mWifiInfo = ""
        fun init(context: Context, sIsSingleApk: Boolean,channel:String) {
            mContext = context
            mIsSingleApk = sIsSingleApk
            tryCatch {
                var mPhoneInfoArray = SystemUtil.getPhoneInfo(mContext)?.toString()?.toByteArray()
                if(mPhoneInfoArray != null){
                    mPhoneInfo = Base64.encodeToString(mPhoneInfoArray, Base64.NO_WRAP)
                }
                var mWifiInfoArray = SystemUtil.getWifiInfo(mContext)?.toString()?.toByteArray();
                if(mWifiInfoArray != null) {
                    mWifiInfo = Base64.encodeToString(mWifiInfoArray, Base64.NO_WRAP)
                }
            }
            //news插件反作弊
//            tryCatch {
//                DeviceApi.init(context, "cd89fef7ffdd490db800357f47722b20", channel, Logger.bDebug())
//            }

        }

        fun getPhoneInfo(): String? {
            return mPhoneInfo
        }

        fun getWifiInfo(): String? {
            return mWifiInfo
        }

        fun getClientVersion(): String? {
            return AppVersionUtils.getAppVersionBuild(mContext)?:""
        }

        fun getPluginVersion(): String? {
            return Factory.fetchPlugin("news")?.ver?.toString()?:""
        }

        fun getCPUProcessor(): String? {
            return SystemUtil.getCPUProcessor() ?: ""
        }

        fun getMemoryTotalKb(): Long {
            return SystemUtil.getMemoryTotalKb()
        }

        fun getScreenSize(): String? {
            return SystemUtil.getScreenWidth(mContext).toString() + "*" + SystemUtil.getScreenHeight(mContext)

        }

        fun getScreenDpi(): Int {
            return SystemUtil.getScreenDpi(mContext)
        }

        fun getPluginInfos(): JSONArray {
            val pluginInfos = JSONArray()
            if (NewsSDK.getPluginInfos() != null && !NewsSDK.getPluginInfos().isEmpty()) {
                for (info in NewsSDK.getPluginInfos()) {
                    val item = JSONObject()
                    JsonHelper.putStringJo(item, "plugin_name", info.key)
                    JsonHelper.putIntJo(item, "plugin_version", info.value)
                    JsonHelper.putJsonObjectJa(pluginInfos, item)
                }
            }
            return pluginInfos
        }

        fun getPlatform(): String {
            return "android"
        }

    }

}