package com.qihoo360.mobilesafe.reward.container.toutiao

import android.content.Context
import android.text.TextUtils
import android.util.AttributeSet
import android.view.View
import android.widget.Toast
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.control.sync.DownloadSatusManager
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.ApullTemplateBase
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullTouTiao
import com.qihoo360.apullsdk.apull.protocol.network.impl.ReportNetworkTouTiao
import com.qihoo360.apullsdk.apull.view.impl.ContainerApullTouTiaoBase
import com.qihoo360.apullsdk.support.cache.ApullTemplateCacheUtil
import com.qihoo360.apullsdk.utils.NetUtil
import com.qihoo360.apullsdk.videoad.view.AdOperationListener
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.container.displayImage
import com.qihoo360.mobilesafe.reward.data.ApullItemWrapper
import com.qihoo360.mobilesafe.reward.data.RewardRecordManager
import com.qihoo360.mobilesafe.reward.presenter.view.RewardView
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardDownloadDialog
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.mobilesafe.ui.common.dialog.CommonDialog
import kotlinx.android.synthetic.main.apullsdk_container_apull_toutiao_2606.view.*


val TAG = "ContainerApullTouTiao2606"

class ContainerApullTouTiao2606 :ContainerApullTouTiaoBase {

    constructor(context: Context, template: ApullTemplateBase?, listener: AdOperationListener) : super(context, template, listener)

    constructor(context: Context, template: ApullTemplateBase?) : super(context, template)

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs)

    constructor(context: Context, attrs: AttributeSet, defStyle: Int) : super(context, attrs, defStyle)

    override fun initView(template: ApullTemplateBase?) {
        View.inflate(context, R.layout.apullsdk_container_apull_toutiao_2606, this)
        DownloadSatusManager.register(this)
    }

    override fun updateView(template: ApullTemplateBase?) {
        if (template == null || template !is TemplateApullTouTiao || mTemplateApullTouTiao === template) {
            return
        }

        visibility = View.VISIBLE
        mTemplateApullTouTiao = template
        apullTouTiaoItem = mTemplateApullTouTiao.defaultItem

        if (mTemplateApullTouTiao != null && mTemplateApullTouTiao.toutiao_list != null && mTemplateApullTouTiao.toutiao_list.size > 0) {
            updateImage()
            updateText()
        }
        debugColor()
        addClickLister()
    }

    private fun debugColor() {
        if(Logger.bDebug()) {
            this.setBackgroundColor(resources.getColor(R.color.progress_yellow))
        }
    }


    private fun addClickLister() {
        mRoot2606?.setOnClickListener {
            handleAppClick(CLICKTYPE.TYPE_BUTTON)
        }
    }

    private fun updateText() {
        mAppName2606?.text = apullTouTiaoItem.appNameOrTitle
        if(apullTouTiaoItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED){
            mRewardBtn2606?.text = context.getText(R.string.open)
        }else{
            mRewardBtn2606?.text = context.getText(R.string.get_hongbao)
        }
    }

    override fun onThemeChanged() {
        updateThemeColor()
    }

    private fun updateThemeColor() {
    }

    private fun updateImage() {
        mLargeImage2606?.apply {
            val url = apullTouTiaoItem?.icon
            displayImage(url)
        }
    }

    override fun onImageEnableChange(enable: Boolean) {
         updateImage()
    }

    override fun getTemplate(): ApullTemplateBase {
        return mTemplateApullTouTiao
    }

    override fun updateDownloadStatus() {
        post{
            updateText()
        }
    }

    override fun openApp(isAuto:Boolean) {
        RewardRecordManager.setLastRewardUniqueId(context,apullTouTiaoItem?.unique_id)
        super.openApp(isAuto)
    }


    override fun onApkInstalled(downloadid: String, iType: Int) {
        if (!TextUtils.isEmpty(downloadid) && downloadid == mTemplateApullTouTiao.downloadid) {
            apullTouTiaoItem.status = ApullConst.STATUS_TYPE_INSTALL_FINISHED
            apullTouTiaoItem.iType = iType
            if (!mTemplateApullTouTiao.installed_reported) {
                mTemplateApullTouTiao.installed_reported = true
                ApullReportManager.reportApullTouTiao(context, mTemplateApullTouTiao, ReportNetworkTouTiao.REPORTTYPE.INSTALL_FINISH, 0)
                ApullReportManager.reportApullSspTouTiaoInstalled(context, mTemplateApullTouTiao)
                ApullTemplateCacheUtil.refresh(mTemplateApullTouTiao)
            }
            updateDownloadStatus()

            Logger.d(TAG, "onApkInstalled downloadid:$downloadid")
        }
    }

    private val mDownloadListener = object : RewardDownloadDialog.DownloadListener {

        override fun onClick() {
            apullTouTiaoItem?.apply {
                if (apullTouTiaoItem.status == ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED) {
                    startDownloadAppNoDialog(CLICKTYPE.TYPE_BUTTON)
                    return
                }
                handleAppClick(CLICKTYPE.TYPE_BUTTON)
            }
        }

        override fun onDismiss() {
            apullTouTiaoItem?.apply {
                if(apullTouTiaoItem.status == ApullConst.STATUS_TYPE_DOWNLOADING ||
                        apullTouTiaoItem.status == ApullConst.STATUS_TYPE_UPDATE_PROGRESS){
                    handleAppClick(CLICKTYPE.TYPE_BUTTON)
                }
            }
        }

        override fun onContinue() {
            apullTouTiaoItem?.apply {
                if (apullTouTiaoItem.status == ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED) {
                    startDownloadAppNoDialog(CLICKTYPE.TYPE_BUTTON)
                }
            }
        }

    }

    fun startDownloadAppNoDialog(type: CLICKTYPE) {
        super.startDownloadApp(type)
    }

    override fun startDownloadApp(type: CLICKTYPE) {
        if(context is RewardView){
            (context as? RewardView)?.showRewardDownloadDialog(
                    ApullItemWrapper(mTemplateApullTouTiao),mDownloadListener)
        }
        RewardRecordManager.setLastRewardUniqueId(context,apullTouTiaoItem?.unique_id)

        super.startDownloadApp(type)
    }

    override fun startDownloadAppWithTips(type:CLICKTYPE ) {
        if (NetUtil.isConnected(context)) {
            if (!NetUtil.isWifiConnected(context)) {
                val title = context.getString(R.string.tips_title)
                val body = context.getString(R.string.tips_body_start_download)
                val ok = context.getString(R.string.ok)
                val cancel = context.getString(R.string.cancel)
                val dialog = CommonDialog(context,title,body)
                dialog.setBtnOk(ok) {
                    startDownloadApp(type)
                    dialog.dismiss()
                }
                dialog.setBtnCancel(cancel){
                    dialog.dismiss()
                }
                dialog.show()

            } else {
                startDownloadApp(type)
            }
        } else {
            Toast.makeText(context, R.string.hongbao_net_no_connect_tips, Toast.LENGTH_SHORT).show()
        }
    }
}